set rev(ether_def.tcl) {$Header: /home/cvs/PacketMaker/ether_def.tcl,v 1.1.1.1 2002/12/02 01:37:04 clif Exp $}
#####################################################################
;# NAME:   ether.tcl
;# AUTHOR: Clif Flynt
;# DATE:   11/2002
;# DESC:   Definitions for ethernet packets.
;#         
;#         
;#
;# PARAMETERS:  
;#
;#
#####################################################################
# This code is written and copyrighted by Clif Flynt, 2002
#
# It is licenced for public use with these terms:
#
#  This licence agreement must remain intact with the code.
# 
#  You may use this code freely for non-commercial purposes.
#
#  You may examine and modify the code to your heart's content.
#
#  You may not claim to have authored the code (aside from modifications
#  you may have made.)
#
#  You may not distribute the code without this license agreement
#
#  You may not sell this code or distribute it with a commercial product
#      without arrangements with Noumena Corporation.
#
#  Maintenance, extension, modification, etc can be performed by:
#
#   Noumena Corporation
#   9300 Fleming Rd.
#   Dexter, MI  48130
#
#   Contact: clif@noucorp.com
#
#####################################################################
package provide ether 1.0
namespace eval ether {
  variable fields 
  
  set fields { 
      dest 0 48
      src  48 48
      type 96 16
      payload 112 {[expr 8 * [llength $val]]}
      }

  variable lookup

  set lookup(type.IP)                   0x0800
  set lookup(type.IP.def)                   {IP in RFC894}
  set lookup(type.ARP)                   0x0806
  set lookup(type.ARP.def)                   {ARP in RFC894}
  set lookup(type.RARP)                   0x8035
  set lookup(type.RARP.def)                   {RARP in RFC894}
}
