set rev(ip_cmp_def.tcl) {$Header: /home/cvs/PacketMaker/icmp_def.tcl,v 1.1.1.1 2002/12/02 01:37:04 clif Exp $}
#####################################################################
;# NAME:   ip_cmp_def.tcl
;# AUTHOR: Clif Flynt
;# DATE:   11/2002
;# DESC:   Definitions for ICMP packets
;#         
;#         
;#
;# PARAMETERS:  
;#
;#
#####################################################################
# This code is written and copyrighted by Clif Flynt, 2002
#
# It is licenced for public use with these terms:
#
#  This licence agreement must remain intact with the code.
# 
#  You may use this code freely for non-commercial purposes.
#
#  You may examine and modify the code to your heart's content.
#
#  You may not claim to have authored the code (aside from modifications
#  you may have made.)
#
#  You may not distribute the code without this license agreement
#
#  You may not sell this code or distribute it with a commercial product
#      without arrangements with Noumena Corporation.
#
#  Maintenance, extension, modification, etc can be performed by:
#
#   Noumena Corporation
#   9300 Fleming Rd.
#   Dexter, MI  48130
#
#   Contact: clif@noucorp.com
#
#####################################################################

package provide icmp 1.0
namespace eval icmp {
  variable fields 
  
  set fields { 
      type 0 8
      code 8 8 
      checksum 16 16 }

  variable lookup

  set lookup(type.ICMP_ECHOREPLY)                  0       
  set lookup(type.ICMP_ECHOREPLY.def)                 {Echo Reply }
  set lookup(type.ICMP_DEST_UNREACH)               3       
  set lookup(type.ICMP_DEST_UNREACH.def)              {Destination Unreachable }
  set lookup(type.ICMP_SOURCE_QUENCH)              4       
  set lookup(type.ICMP_SOURCE_QUENCH.def)             {Source Quench }
  set lookup(type.ICMP_ECHO)                       8       
  set lookup(type.ICMP_ECHO.def)                      {Echo Request }
  set lookup(type.ICMP_TIME_EXCEEDED)              11      
  set lookup(type.ICMP_TIME_EXCEEDED.def)             {Time Exceeded }
  set lookup(type.ICMP_PARAMETERPROB)              12      
  set lookup(type.ICMP_PARAMETERPROB.def)             {Parameter Problem }
  set lookup(type.ICMP_TIMESTAMP)                  13      
  set lookup(type.ICMP_TIMESTAMP.def)                 {Timestamp Request }
  set lookup(type.ICMP_TIMESTAMPREPLY)             14      
  set lookup(type.ICMP_TIMESTAMPREPLY.def)            {Timestamp Reply }
  set lookup(type.ICMP_INFO_REQUEST)               15      
  set lookup(type.ICMP_INFO_REQUEST.def)              {Information Request }
  set lookup(type.ICMP_INFO_REPLY)                 16      
  set lookup(type.ICMP_INFO_REPLY.def)                {Information Reply }
  set lookup(type.ICMP_ADDRESS)                    17      
  set lookup(type.ICMP_ADDRESS.def)                   {Address Mask Request }
  set lookup(type.ICMP_ADDRESSREPLY)               18      
  set lookup(type.ICMP_ADDRESSREPLY.def)              {Address Mask Reply }
  set lookup(type.NR_ICMP_TYPES)                   18      
  set lookup(ICMP_DEST_UNREACH.ICMP_NET_UNREACH)                0       
  set lookup(ICMP_DEST_UNREACH.ICMP_NET_UNREACH.def)               {Network Unreachable }
  set lookup(ICMP_DEST_UNREACH.ICMP_HOST_UNREACH)               1       
  set lookup(ICMP_DEST_UNREACH.ICMP_HOST_UNREACH.def)              {Host Unreachable }
  set lookup(ICMP_DEST_UNREACH.ICMP_PROT_UNREACH)               2       
  set lookup(ICMP_DEST_UNREACH.ICMP_PROT_UNREACH.def)              {Protocol Unreachable }
  set lookup(ICMP_DEST_UNREACH.ICMP_PORT_UNREACH)               3       
  set lookup(ICMP_DEST_UNREACH.ICMP_PORT_UNREACH.def)              {Port Unreachable }
  set lookup(ICMP_DEST_UNREACH.ICMP_FRAG_NEEDED)                4       
  set lookup(ICMP_DEST_UNREACH.ICMP_FRAG_NEEDED.def)               {Fragmentation Needed/DF set }
  set lookup(ICMP_DEST_UNREACH.ICMP_SR_FAILED)                  5       
  set lookup(ICMP_DEST_UNREACH.ICMP_SR_FAILED.def)                 {Source Route failed }
  set lookup(ICMP_DEST_UNREACH.ICMP_NET_UNKNOWN)                6       
  set lookup(ICMP_DEST_UNREACH.ICMP_HOST_UNKNOWN)               7       
  set lookup(ICMP_DEST_UNREACH.ICMP_HOST_ISOLATED)              8       
  set lookup(ICMP_DEST_UNREACH.ICMP_NET_ANO)                    9       
  set lookup(ICMP_DEST_UNREACH.ICMP_HOST_ANO)                   10      
  set lookup(ICMP_DEST_UNREACH.ICMP_NET_UNR_TOS)                11      
  set lookup(ICMP_DEST_UNREACH.ICMP_HOST_UNR_TOS)               12      
  set lookup(ICMP_DEST_UNREACH.ICMP_PKT_FILTERED)               13      
  set lookup(ICMP_DEST_UNREACH.ICMP_PKT_FILTERED.def)              {Packet filtered }
  set lookup(ICMP_DEST_UNREACH.ICMP_PREC_VIOLATION)             14      
  set lookup(ICMP_DEST_UNREACH.ICMP_PREC_VIOLATION.def)            {Precedence violation }
  set lookup(ICMP_DEST_UNREACH.ICMP_PREC_CUTOFF)                15      
  set lookup(ICMP_DEST_UNREACH.ICMP_PREC_CUTOFF.def)               {Precedence cut off }
  set lookup(ICMP_DEST_UNREACH.NR_ICMP_UNREACH)                 15      
  set lookup(ICMP_DEST_UNREACH.NR_ICMP_UNREACH.def)                {instead of hardcoding immediate value }
  set lookup(ICMP_REDIRECT.ICMP_REDIR_NET)                  0       
  set lookup(ICMP_REDIRECT.ICMP_REDIR_NET.def)                 {Redirect Net }
  set lookup(ICMP_REDIRECT.ICMP_REDIR_HOST)                 1       
  set lookup(ICMP_REDIRECT.ICMP_REDIR_HOST.def)                {Redirect Host }
  set lookup(ICMP_REDIRECT.ICMP_REDIR_NETTOS)               2       
  set lookup(ICMP_REDIRECT.ICMP_REDIR_NETTOS.def)              {Redirect Net for TOS }
  set lookup(ICMP_REDIRECT.ICMP_REDIR_HOSTTOS)              3       
  set lookup(ICMP_REDIRECT.ICMP_REDIR_HOSTTOS.def)             {Redirect Host for TOS }
  set lookup(ICMP_TIME_EXCEEDED.ICMP_EXC_TTL)                    0       
  set lookup(ICMP_TIME_EXCEEDED.ICMP_EXC_TTL.def)                   {TTL count exceeded }
  set lookup(ICMP_TIME_EXCEEDED.ICMP_EXC_FRAGTIME)               1       
  set lookup(ICMP_TIME_EXCEEDED.ICMP_EXC_FRAGTIME.def)              {Fragment Reass time exceeded }
  set lookup(ICMP_MINLEN)                     8       
  set lookup(ICMP_MINLEN.def)                    {abs minimum }
  set lookup(ICMP_MASKLEN)                    12      
  set lookup(ICMP_MASKLEN.def)                   {address mask }
  set lookup(type.ICMP_ROUTERADVERT)               9       
  set lookup(type.ICMP_ROUTERADVERT.def)              {router advertisement }
  set lookup(type.ICMP_ROUTERSOLICIT)              10      
  set lookup(type.ICMP_ROUTERSOLICIT.def)             {router solicitation }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_NET)                0       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_NET.def)               {bad net }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_HOST)               1       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_HOST.def)              {bad host }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_PROTOCOL)           2       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_PROTOCOL.def)          {bad protocol }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_PORT)               3       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_PORT.def)              {bad port }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_NEEDFRAG)           4       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_NEEDFRAG.def)          {IP_DF caused drop }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_SRCFAIL)            5       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_SRCFAIL.def)           {src route failed }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_NET_UNKNOWN)        6       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_NET_UNKNOWN.def)       {unknown net }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_HOST_UNKNOWN)       7       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_HOST_UNKNOWN.def)      {unknown host }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_ISOLATED)           8       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_ISOLATED.def)          {src host isolated }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_NET_PROHIB)         9       
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_NET_PROHIB.def)        {net denied }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_HOST_PROHIB)        10      
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_HOST_PROHIB.def)       {host denied }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_TOSNET)             11      
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_TOSNET.def)            {bad tos for net }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_TOSHOST)            12      
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_TOSHOST.def)           {bad tos for host }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_FILTER_PROHIB)      13      
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_FILTER_PROHIB.def)     {admin prohib }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_HOST_PRECEDENCE)    14      
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_HOST_PRECEDENCE.def)   {host prec vio. }
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_PRECEDENCE_CUTOFF)  15      
  set lookup(ICMP_DEST_UNREACH.ICMP_UNREACH_PRECEDENCE_CUTOFF.def) {prec cutoff }
  set lookup(ICMP_REDIRECT.ICMP_REDIRECT_NET)               0       
  set lookup(ICMP_REDIRECT.ICMP_REDIRECT_NET.def)              {for network }
  set lookup(ICMP_REDIRECT.ICMP_REDIRECT_HOST)              1       
  set lookup(ICMP_REDIRECT.ICMP_REDIRECT_HOST.def)             {for host }
  set lookup(ICMP_REDIRECT.ICMP_REDIRECT_TOSNET)            2       
  set lookup(ICMP_REDIRECT.ICMP_REDIRECT_TOSNET.def)           {for tos and net }
  set lookup(ICMP_REDIRECT.ICMP_REDIRECT_TOSHOST)           3       
  set lookup(ICMP_REDIRECT.ICMP_REDIRECT_TOSHOST.def)          {for tos and host }
  set lookup(ICMP_TIME_EXCEEDED.ICMP_TIMXCEED_INTRANS)           0       
  set lookup(ICMP_TIME_EXCEEDED.ICMP_TIMXCEED_INTRANS.def)          {ttl==0 in transit }
  set lookup(ICMP_TIME_EXCEEDED.ICMP_TIMXCEED_REASS)             1       
  set lookup(ICMP_TIME_EXCEEDED.ICMP_TIMXCEED_REASS.def)            {ttl==0 in reass }
  set lookup(ICMP_PARAMETERPROB.ICMP_PARAMPROB_OPTABSENT)        1       
  set lookup(ICMP_PARAMETERPROB.ICMP_PARAMPROB_OPTABSENT.def)       {req. opt. absent }
}
