set rev(ip.tcl) {$Header: /home/cvs/PacketMaker/ip.tcl,v 1.2 2002/12/31 02:40:01 clif Exp $}
#####################################################################
;# NAME:   ip.tcl
;# AUTHOR: Clif Flynt
;# DATE:   11/2002
;# DESC:   Procedures for IP packets
;#         
;#         
;#
;# PARAMETERS:  
;#
;#
#####################################################################
# This code is written and copyrighted by Clif Flynt, 2002
#
# It is licenced for public use with these terms:
#
#  This licence agreement must remain intact with the code.
# 
#  You may use this code freely for non-commercial purposes.
#
#  You may examine and modify the code to your heart's content.
#
#  You may not claim to have authored the code (aside from modifications
#  you may have made.)
#
#  You may not distribute the code without this license agreement
#
#  You may not sell this code or distribute it with a commercial product
#      without arrangements with Noumena Corporation.
#
#  Maintenance, extension, modification, etc can be performed by:
#
#   Noumena Corporation
#   9300 Fleming Rd.
#   Dexter, MI  48130
#
#   Contact: clif@noucorp.com
#
#####################################################################

package provide ip 1.0

namespace eval ip {
    variable fields
    namespace export genPacket 
    
    proc genPacket {} {
      upvar fieldArray dataArray
      variable fields
      variable pFields
      variable lookup

      # Need to calculate TCP/UDP checksum with pseudoHeader
      #  that includes IP info.
puts "PROTOCOL TEST NEXT"
      switch [string toupper $dataArray(protocol)] {
          UDP	-
	   17	{
puts "DOING UDP CHECKSUM"
	        set dataArray(zero) 0
		set dataArray(pLength) [llength $dataArray(payload)]
                set pseudo [packet::MakePayload $pFields lookup dataArray]
		set dataArray(payload) [udp::fillCheckSum $dataArray(payload) $pseudo]
	   }
	  TCP	-
	    6	{
puts "DOING TCP CHECKSUM"
	        set dataArray(zero) 0
		set dataArray(pLength) [llength $dataArray(payload)]
                set pseudo [packet::MakePayload $pFields lookup dataArray]
		set dataArray(payload) [tcp::fillCheckSum $dataArray(payload) $pseudo]
	   }
      }

      set byteStream [packet::MakePayload $fields lookup dataArray]

      set byteStream [fillCheckSum $byteStream]

      set dataArray(packet) $byteStream
    }
    
    proc fillCheckSum {byteStream} {
      variable fields
      upvar 2 fieldArray dataArray
      set p [lsearch $fields checksum]
      set pos [expr ([lindex $fields [incr p] ] / 8)]
      set len [expr ([lindex $fields [incr p]] / 8) -1]
      set checksum [packet::CheckSum [lrange $byteStream 0 [expr 19 + [llength $dataArray(options)]]]]

      set byteStream [eval lreplace [list $byteStream] $pos [expr $pos + $len] $checksum]
      return $byteStream
    }

}



